
var additional_options = false;

var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday',
    'Saturday'];

var months = ['January', 'February', 'March', 'April', 'May', 'June', 'July',
    'August', 'September', 'November', 'December'];

var number_of_days_to_display = 60;

var month_names = {'1': 'Jan', '2': 'Feb', '3': 'Mar', '4': 'Apr', '5':
    'May', '6': 'Jun', '7': 'Jul', '8': 'Aug', '9': 'Sep', '10': 'Oct',
    '11': 'Nov', '12': 'Dec'}

var last_saved;

var undo = {};

if (localStorage.calendar)
    {
    var calendar = JSON.parse(localStorage.calendar);
    }
else
    {
    var calendar = [];
    localStorage.calendar = JSON.stringify(calendar);
    }

if (localStorage.completed)
    {
    var completed = JSON.parse(localStorage.completed);
    }
else
    {
    var completed = [];
    localStorage.completed = JSON.stringify(completed);
    }

if (localStorage.scratchpad)
    {
    document.getElementById('scratchpad').value = localStorage.scratchpad;
    }

if (localStorage.settings)
    {
    var settings = JSON.parse(localStorage.settings);
    }
else
    {
    var settings = {'hide_login': false};
    localStorage.settings = JSON.stringify(settings);
    }

if (localStorage.todo)
    {
    var todo = JSON.parse(localStorage.todo);
    }
else
    {
    var todo = [];
    localStorage.todo = JSON.stringify(todo);
    }

function add_to_calendar(regular_expression, description, exceptions, interval)
    {
    var length = calendar.length;
    if (typeof interval === 'undefined')
        {
        calendar[calendar.length] = [regular_expression, description,
            exceptions];
        }
    else
        {
        calendar[calendar.length] = [regular_expression, description,
            exceptions, interval];
        }
    save_all();
    update_calendar_display();
    }

function add_to_todo(description)
    {
    var length = todo.length;
    var entry = [{'completed': false, 'delete': false, 'invisible': false,
        'unsure': false, 'important': false, 'user_defined': false,
        'in_progress': false, 'active': false, 'background': false,
        'Problems': false}, description];
    todo[todo.length] = entry;
    save_all();
    update_todo_display();
    }

function format_date(date, postscript, dates_already_displayed, element_type)
    {
    if (typeof element_type === 'undefined')
        {
        element_type = 'p';
        }
    var result = '<' + element_type + ' class="date';
    if (date.getDay() == 0 || date.getDay() == 6)
        {
        result += ' weekend';
        }
    result += ' ' + days[date.getDay()];
    result += '">';
    result += days[date.getDay()];
    result += ', ';
    result += months[date.getMonth()];
    result += ' ';
    result += date.getDate();
    result += ' ';
    result += date.getFullYear();
    if (dates_already_displayed.indexOf(result) === -1)
        {
        dates_already_displayed[dates_already_displayed.length] = result;
        }
    else
        {
        return '';
        }
    result += postscript;
    result += '</' + element_type + '>';
    return result;
    }

function format_event(index, date)
    {
    var result = '<p class="event">';
    var instance = date.getDay() + '_' + date.getDate() + '_' + (date.getMonth() + 1) + '_' + date.getFullYear();
    result += '<input type="checkbox" class="delete_instance" id="delete_' + index + '_' + instance + '">';
    result += calendar[index][1];
    result += '</p>';
    return result;
    }

function update_calendar_display()
    {
    var dates_already_displayed = [];
    var markers = '';
    var result = '';
    result += format_date(new Date(), '', [], 'h1');
    var weekdays = 0;
    var all_days = 0;
    for (var days_ahead = 0; days_ahead < number_of_days_to_display; ++days_ahead)
        {
        var date = new Date();
        date.setTime(date.getTime() + days_ahead * 24 * 60 * 60 * 1000);
        if (days_ahead)
            {
            ++all_days;
            markers += '<span class="markers">';
            if (date.getDay() === 0)
                {
                markers += '<span class="Sunday_marker">&perp;</span>';
                }
            else if (date.getDay() === 6)
                {
                markers += '<span class="Saturday_marker">&perp;</span>';
                }
            else
                {
                markers += '&perp;';
                ++weekdays;
                }
            markers += '</span>';
            }
        for (var event_index = 0; event_index < calendar.length; ++event_index)
            {
            if (calendar[event_index] === null)
                {
                continue;
                }
            if (calendar[event_index].length === 4)
                {
                var test_date = new Date();
                var reference_date = calendar[event_index][0].replace(/-0/g,
                    '-').split('-');
                test_date.setFullYear(Number(reference_date[0]));
                test_date.setMonth(Number(reference_date[1]) - 1);
                test_date.setDate(Number(reference_date[2]));
                test_date.setHours(0);
                test_date.setMinutes(0);
                test_date.setSeconds(0);
                var difference = (Math.abs(date.getTime() -
                    test_date.getTime()) %
                    (24 * 60 * 60 * 1000 * Number(calendar[event_index][2])));
                if (date > test_date && difference < 24 * 60 * 60 * 1000)
                    {
                    var postscript = ' ';
                    postscript += '<span class="days_ahead">(<span class="days_ahead_number">';
                    postscript += weekdays;
                    postscript += '</span> weekdays and <span class="days_ahead_number">';
                    postscript += all_days;
                    postscript += '</span> days)</span> ';
                    if (markers)
                        {
                        markers += '</span>';
                        postscript += markers;
                        }
                    else
                        {
                        postscript = ' <span class="today">Today</span>';
                        }
                    if (calendar[event_index][2].indexOf(event_index + '_' + date.getDay() + '_' + date.getDate() + '_' + (date.getMonth() + 1) + '_' + date.getFullYear()) !== -1)
                        {
                        result += format_date(postscript, date, dates_already_displayed);
                        result += format_event(event_index, date);
                        }
                    }
                }
            else if (new RegExp(calendar[event_index][0]).exec(date.toDateString())
                && calendar[event_index][1] && format_event(event_index, date))
                {
                var postscript = ' ';
                postscript += '<span class="days_ahead">(<span class="days_ahead_number">';
                postscript += weekdays;
                postscript += '</span> weekdays and <span class="days_ahead_number">';
                postscript += all_days;
                postscript += '</span> days)</span> ';
                if (markers)
                    {
                    postscript += markers;
                    }
                else
                    {
                    postscript = ' <span class="today">Today</span>';
                    }
                if (calendar[event_index][2].indexOf(event_index + '_' + date.getDay() + '_' + date.getDate() + '_' + (date.getMonth() + 1) + '_' + date.getFullYear()) === -1)
                    {
                    result += format_date(date, postscript, dates_already_displayed);
                    result += format_event(event_index, date);
                    }
                }
            }
        }
    document.getElementById('calendar_entries').innerHTML = result;
    var elements = document.getElementsByClassName('delete_instance');
    for(var index = 0; index < elements.length; ++index)
        {
        var split_id = elements[index].id.split('_');
        var id = Number(split_id[1]);
        var day = split_id[2];
        var date = split_id[3];
        var month = split_id[4];
        var year = split_id[5];
        // Click function courtesy of:
        // http://stackoverflow.com/questions/12252959/how-do-i-freeze-a-functions-variables-in-a-closure
        function click_function(id, date, day, month, year)
            {  
            return function()
                {
                if (calendar[id][2].indexOf(id + '_' + day + '_' + date + '_' + month + '_' + year) === -1)
                    {
                    calendar[id][2][calendar[id][2].length] = id + '_' + day + '_' + date + '_' + month + '_' + year;
                    save_all();
                    update_calendar_display();  
                    }  
                }
            }
        elements[index].onclick = click_function(id, date, day, month, year);
        /*
        eval("elements[index].onclick = function() { if (calendar[" + id + "][2].indexOf('" +
            id + '_' + day + '_' + date + '_' + month + '_' + year +
            "') === -1) { calendar[id][2][calendar[id][2].length] = '" + 
            id + '_' + day + '_' + date + '_' + month + '_' + year +
            "'; save_all(); update_calendar_display(); } }");
        /*
        elements[index].onclick = function()
            {
            if (calendar[id][2].indexOf(id + '_' + day + '_' + date + '_' + month + '_' + year) === -1)
                {
                calendar[id][2][calendar[id][2].length] = id + '_' + day + '_' + date + '_' + month + '_' + year;
                }
            save_all();
            update_calendar_display();
            }
            */
        }
    }

if (settings.hide_login)
    {
    document.getElementById('initial_options').style.display = 'none';
    }

function update_todo_display()
    {
    var result = '';
    todo.sort(function(a, b)
        {
        if (a && !b)
            {
            return 1;
            }
        else if (!a && b)
            {
            return -1;
            }
        else if (a[1] && !b[1])
            {
            return 1;
            }
        else if (!a[1] && b[1])
            {
            return -1;
            }
        else if (a[1].toLowerCase() > b[1].toLowerCase())
            {
            return 1;
            }
        else if (a[1].toLowerCase() === b[1].toLowerCase())
            {
            return 0;
            }
        else
            {
            return -1;
            }
        });
    result += '<table cellspacing="0"><tbody>';
    for (var index = 0; index < todo.length; ++index)
        {
        var classes = 'description';
        if (todo[index][0]['completed'] || todo[index][0]['delete'] ||
            todo[index][0]['invisible'] &&
            !document.forms.todo.show_invisible_items.checked)
            {
            continue;
            }
        result += '<tr>';
        result += '<td class="box completed">';
        result += '<label class="reader" for="todo_completed_' + index;
        result += '">Completed:</label><input type="checkbox" ';
        if (todo[index][0]['completed'])
            {
            result += 'checked="checked" ';
            }
        result += 'class="todo_checkbox" id="todo_completed_' + index + '"></td>\n';
        result += '<td class="box delete">';
        result += '<label class="reader" for="todo_delete_' + index;
        result += '">Delete:</label><input type="checkbox" ';
        if (todo[index][0]['delete'])
            {
            result += 'checked="checked" ';
            }
        result += 'class="todo_checkbox" id="todo_delete_' + index + '"></td>\n';
        result += '<td class="box invisible">';
        result += '<label class="reader" for="todo_invisible_' + index;
        result += '">Invisible:</label><input type="checkbox" ';
        if (todo[index][0]['invisible'])
            {
            result += 'checked="checked" ';
            classes += ' invisible';
            }
        result += 'class="todo_checkbox" id="todo_invisible_' + index + '"></td>\n';
        result += '<td class="box unsure">'
        result += '<label class="reader" for="todo_unsure_' + index;
        result += '">Unsure:</label><input type="checkbox" ';
        if (todo[index][0]['unsure'])
            {
            result += 'checked="checked" ';
            classes += ' unsure';
            }
        result += 'class="todo_checkbox" id="todo_unsure_' + index + '"></td>\n';
        result += '<td class="box important"><label class="reader" for="todo_important_' + index;
        result += '">Important:</label><input type="checkbox" ';
        if (todo[index][0]['important'])
            {
            result += 'checked="checked" ';
            classes += ' important';
            }
        result += 'class="todo_checkbox" id="todo_important_' + index + '"></td>\n';
        result += '<td class="box user_defined"><label class="reader" for="todo_user_defined_' + index;
        result += '">You define it</label><input type="checkbox" ';
        if (todo[index][0]['user_defined'])
            {
            result += 'checked="checked" ';
            classes += ' user_defined';
            }
        result += 'class="todo_checkbox" id="todo_user_defined_' + index + '"></td>\n';
        result += '<td class="box in_progress"><label class="reader" for="todo_in_progress_' + index;
        result += '">In progress</label><input type="checkbox" ';
        if (todo[index][0]['in_progress'])
            {
            result += 'checked="checked" ';
            classes += ' in_progress';
            }
        result += 'class="todo_checkbox" id="todo_in_progress_' + index + '"></td>\n';
        result += '<td class="box active"><label class="reader" for="todo_active_' + index;
        result += '">Active</label><input type="checkbox" ';
        if (todo[index][0]['active'])
            {
            result += 'checked="checked" ';
            classes += ' active';
            }
        result += 'class="todo_checkbox" id="todo_active_' + index + '"></td>\n';
        result += '<td class="box background"><label class="reader" for="todo_background_' + index;
        result += '">Background</label><input type="checkbox" ';
        if (todo[index][0]['background'])
            {
            result += 'checked="checked" ';
            classes += ' background';
            }
        result += 'class="todo_checkbox" id="todo_background_' + index + '"></td>\n';
        result += '<td class="box problems"><label class="reader" for="todo_problems_' + index;
        result += '">Problems</label><input type="checkbox" ';
        if (todo[index][0]['problems'])
            {
            result += 'checked="checked" ';
            classes += ' problems';
            }
        result += 'class="todo_checkbox" id="todo_problems_' + index + '"></td>\n';
        result += '<td class="' + classes + '">' + todo[index][1] + '</td>\n';
        result += '</tr>';
        }
    result += '</tbody></table>\n';
    document.getElementById('todo-contents').innerHTML = result;
    document.getElementById('next_entry').focus();
    var elements = document.getElementsByClassName('todo_checkbox');
    for(var index = 0; index < elements.length; ++index)
        {
        elements[index].onclick = function()
            {
            var split = this.id.split('_');
            var category = '';
            for (var inner = 1; inner < split.length - 1; ++inner)
                {
                category += split[inner];
                if (inner < split.length - 2)
                    {
                    category += '_';
                    }
                }
            var id = Number(split[split.length - 1]);
            if (category === 'completed')
                {
                completed[completed.length] = [todo[id], new Date().getTime()];
                }
            if (this.checked)
                {
                todo[id][0][category] = true;
                }
            else
                {
                todo[id][0][category] = false;
                }
            save_all();
            update_todo_display();
            }
        }
    }

function save_all()
    {
    undo.calendar = localStorage.calendar;
    undo.completed = localStorage.completed;
    undo.scratchpad = localStorage.scratchpad;
    undo.todo = localStorage.todo;
    localStorage.calendar = JSON.stringify(calendar);
    localStorage.completed = JSON.stringify(completed);
    localStorage.scratchpad = document.getElementById('scratchpad').value;
    localStorage.todo = JSON.stringify(todo);
    document.getElementById('undo').style.opacity = 1;
    }

function undo_last_action()
    {
    calendar = JSON.parse(undo.calendar);
    update_calendar_display();
    completed = JSON.parse(undo.completed);
    document.getElementById('scratchpad').value = undo.scratchpad;
    todo = JSON.parse(undo.todo);
    update_todo_display();
    document.getElementById('undo').style.opacity = .5;
    }

document.getElementById('undo').onclick = undo_last_action;
document.getElementById('scratchpad').onchange = save_all;

document.getElementById('days').onchange = document.getElementById('every').onchange = document.getElementById('day').onchange = function()
    {
    document.getElementById('yearly_based').checked = false;
    }

document.getElementById('more_options').onclick = function()
    {
    document.getElementById('additional_options').style.display = 'block';
    document.getElementById('more_options').style.display = 'none';
    additional_options = true;
    return false;
        }

document.getElementById('less_options').onclick = function()
    {
    additional_options = false;
    document.getElementById('additional_options').style.display = 'none';
    document.getElementById('more_options').style.display = 'inline';
    return false;
    }

document.getElementById('save_calendar').onclick = function()
    {
    if (additional_options && !document.getElementById('yearly_based').checked)
        {
        var regular_expression = document.getElementById('day').value.substr(0,
            3);
        regular_expression += ' ... ';
        switch(document.getElementById('every').value)
            {
            case 'Every':
                regular_expression += '..';
            break;
            case 'Every First and Third':
                regular_expression += '(01|02|03|04|05|06|07|15|16|17|18|19|20|21|22)';
            break;
            case 'Every Second and Fourth':
                regular_expression += '(08|09|10|11|12|13|14|22|23|24|25|26|27|28)';
            break;
            case 'Every First':
                regular_expression += '0[1-7]';
            break;
            case 'Every Second':
                regular_expression += '(08|09|10|11|12|13|14)';
            break;
            case 'Every Third':
                regular_expression += '(15|16|17|18|19|20|21)';
            break;
            case 'Every Fourth':
                regular_expression += '2[2-8]';
            break;
            }
        regular_expression += ' ....';
        }
    else
        {
        var split = document.getElementById('date').value.split('-');
        var split = [document.getElementById('year').value,
            document.getElementById('month').value,
            document.getElementById('date').value];
        var regular_expression = '... ';
        regular_expression += month_names[split[1]];
        regular_expression += ' ';
        if (Number(split[2]) < 10)
            {
            regular_expression += '0';
            }
        regular_expression += split[2];
        regular_expression += ' ';
        if (additional_options && document.getElementById('yearly_based').checked)
            {
            regular_expression += '....';
            }
        else
            {
            regular_expression += split[0];
            }
        }
    if (document.getElementById('days').value)
        {
        var iso8601date = '';
        if (Number(document.getElementById('date').value) < 10)
            {
            iso8601date += '0';
            }
        iso8601date += document.getElementById('date').value + '-';
        if (Number(document.getElementById('month').value) < 10)
            {
            iso8601date += '0';
            }
        iso8601date += document.getElementById('month').value + '0';
        iso8601date += document.getElementById('year').value;
        add_to_calendar(iso8601date,
            document.getElementById('description').value,
            [],
            Number(document.getElementById('days').value));
        }
    else
        {
        add_to_calendar(regular_expression,
            document.getElementById('description').value, []);
        }
    save_all();
    document.getElementById('additional_options').style.display = 'none';
    document.getElementById('description').value = '';
    document.getElementById('date').value = new Date().getDate();
    document.getElementById('month').value = new Date().getMonth() + 1;
    document.getElementById('year').value = new Date().getFullYear();
    document.getElementById('yearly_based').checked = '';
    document.getElementById('every').value = 'Every';
    document.getElementById('day').value = 'Monday';
    document.getElementById('days').value = '';
    return false;
    }

document.getElementById('next_entry').onkeydown = function(event)
    {
    if (event.keyCode == 13)
        {
        add_to_todo(document.getElementById('next_entry').value);
        document.getElementById('next_entry').value = '';
        }
    }

update_calendar_display();
update_todo_display();

document.getElementById('description').style.width = document.getElementById('calendar').style.width;

document.getElementById('show_invisible_items').onclick = update_todo_display;

var past = new Date();
past.setTime(0);

document.getElementById('new_items').onsubmit = document.getElementById('todo').onsubmit = function()
    {
    return false;
    }

var window_width = 630, window_height = 460;
if (document.body && document.body.offsetWidth) {
 window_width = document.body.offsetWidth;
 window_height = document.body.offsetHeight;
}
if (document.compatMode=='CSS1Compat' &&
    document.documentElement &&
    document.documentElement.offsetWidth ) {
 window_width = document.documentElement.offsetWidth;
 window_height = document.documentElement.offsetHeight;
}
if (window.innerWidth && window.innerHeight) {
 window_width = window.innerWidth;
 window_height = window.innerHeight;
}

document.getElementById('date').value = new Date().getDate();
document.getElementById('month').value = new Date().getMonth() + 1;
document.getElementById('year').value = new Date().getFullYear();

document.getElementById('main').style.width = (window_width - 300) + 'px';

// calendar = [];
// localStorage.calendar = '[]';
